Index: wp-admin/includes/dashboard.php
===================================================================
--- wp-admin/includes/dashboard.php	(revision 20575)
+++ wp-admin/includes/dashboard.php	(working copy)
@@ -193,10 +193,8 @@
  * @since 2.5.0
  */
 function wp_dashboard() {
-	global $screen_layout_columns;
-
 	$screen = get_current_screen();
-	$class = 'columns-' . $screen_layout_columns;
+	$class = 'columns-' . get_current_screen()->get_option( 'num_columns' );
 
 ?>
 <div id="dashboard-widgets" class="metabox-holder <?php echo $class; ?>">
Index: wp-admin/includes/screen.php
===================================================================
--- wp-admin/includes/screen.php	(revision 20575)
+++ wp-admin/includes/screen.php	(working copy)
@@ -566,14 +566,15 @@
 	 *
 	 * @param string $option Option ID.
 	 * @param mixed $key Optional. Specific array key for when the option is an array.
+	 * @param mixed $default Optional. The value to return if the option is not set. Default is null.
 	 */
-	public function get_option( $option, $key = false ) {
+	public function get_option( $option, $key = false, $default = null ) {
 		if ( ! isset( $this->_options[ $option ] ) )
-			return null;
+			return $default;
 		if ( $key ) {
 			if ( isset( $this->_options[ $option ][ $key ] ) )
 				return $this->_options[ $option ][ $key ];
-			return null;
+			return $default;
 		}
 		return $this->_options[ $option ];
 	}
@@ -773,6 +774,26 @@
 				</div>
 			</div>
 		<?php
+		// Setup layout columns
+		// Back compat for plugins using the filter instead of add_screen_option()
+		$columns = apply_filters( 'screen_layout_columns', array(), $this->id, $this );
+
+		if ( ! empty( $columns ) && isset( $columns[ $this->id ] ) )
+			$this->add_option( 'layout_columns', array('max' => $columns[ $this->id ] ) );
+
+		global $screen_layout_columns; // Global for back-compat.
+		$screen_layout_columns = 0; 
+		if ( $this->get_option( 'layout_columns' ) ) {
+			$screen_layout_columns = get_user_option("screen_layout_$this->id");
+			$num = $this->get_option( 'layout_columns', 'max' );
+	
+			if ( ! $screen_layout_columns || 'auto' == $screen_layout_columns ) {
+				if ( $this->get_option( 'layout_columns', 'default' ) )
+					$screen_layout_columns = $this->get_option( 'layout_columns', 'default' );
+			}
+		}
+		$this->add_option( 'num_columns', $screen_layout_columns );
+
 		// Add screen options
 		if ( $this->show_screen_options() )
 			$this->render_screen_options();
@@ -907,27 +928,12 @@
 	 * @since 3.3.0
 	 */
 	function render_screen_layout() {
-		global $screen_layout_columns;
-
-		// Back compat for plugins using the filter instead of add_screen_option()
-		$columns = apply_filters( 'screen_layout_columns', array(), $this->id, $this );
-
-		if ( ! empty( $columns ) && isset( $columns[ $this->id ] ) )
-			$this->add_option( 'layout_columns', array('max' => $columns[ $this->id ] ) );
-
-		if ( ! $this->get_option('layout_columns') ) {
-			$screen_layout_columns = 0;
+		if ( ! $this->get_option('layout_columns') )
 			return;
-		}
 
-		$screen_layout_columns = get_user_option("screen_layout_$this->id");
+		$screen_layout_columns = $this->get_option( 'num_columns' );
 		$num = $this->get_option( 'layout_columns', 'max' );
 
-		if ( ! $screen_layout_columns || 'auto' == $screen_layout_columns ) {
-			if ( $this->get_option( 'layout_columns', 'default' ) )
-				$screen_layout_columns = $this->get_option( 'layout_columns', 'default' );
-		}
-
 		?>
 		<h5 class="screen-layout"><?php _e('Screen Layout'); ?></h5>
 		<div class='columns-prefs'><?php
Index: wp-admin/edit-link-form.php
===================================================================
--- wp-admin/edit-link-form.php	(revision 20575)
+++ wp-admin/edit-link-form.php	(working copy)
@@ -77,7 +77,7 @@
 
 <div id="poststuff">
 
-<div id="post-body" class="metabox-holder columns-<?php echo 1 == $screen_layout_columns ? '1' : '2'; ?>">
+<div id="post-body" class="metabox-holder columns-<?php echo 1 == get_current_screen()->get_option( 'num_columns' ) ? '1' : '2'; ?>">
 <div id="post-body-content">
 <div id="namediv" class="stuffbox">
 <h3><label for="link_name"><?php _ex('Name', 'link name') ?></label></h3>
Index: wp-admin/edit-form-advanced.php
===================================================================
--- wp-admin/edit-form-advanced.php	(revision 20575)
+++ wp-admin/edit-form-advanced.php	(working copy)
@@ -277,7 +277,7 @@
 
 <div id="poststuff">
 
-<div id="post-body" class="metabox-holder columns-<?php echo 1 == $screen_layout_columns ? '1' : '2'; ?>">
+<div id="post-body" class="metabox-holder columns-<?php echo 1 == get_current_screen()->get_option( 'num_columns' ) ? '1' : '2'; ?>">
 <div id="post-body-content">
 <?php if ( post_type_supports($post_type, 'title') ) { ?>
 <div id="titlediv">