Index: class-wp-ms-sites-list-table.php
===================================================================
--- class-wp-ms-sites-list-table.php	(revision 21296)
+++ class-wp-ms-sites-list-table.php	(working copy)
@@ -143,7 +143,7 @@
 	function get_columns() {
 		$blogname_columns = ( is_subdomain_install() ) ? __( 'Domain' ) : __( 'Path' );
 		$sites_columns = array(
-			'cb'          => '<input type="checkbox" />',
+			'cb'          => '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />',
 			'blogname'    => $blogname_columns,
 			'lastupdated' => __( 'Last Updated' ),
 			'registered'  => _x( 'Registered', 'site' ),
Index: class-wp-posts-list-table.php
===================================================================
--- class-wp-posts-list-table.php	(revision 21296)
+++ class-wp-posts-list-table.php	(working copy)
@@ -261,7 +261,7 @@
 
 		$posts_columns = array();
 
-		$posts_columns['cb'] = '<input type="checkbox" />';
+		$posts_columns['cb'] = '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />';
 
 		/* translators: manage posts column name */
 		$posts_columns['title'] = _x( 'Title', 'column name' );
Index: class-wp-media-list-table.php
===================================================================
--- class-wp-media-list-table.php	(revision 21296)
+++ class-wp-media-list-table.php	(working copy)
@@ -126,7 +126,7 @@
 
 	function get_columns() {
 		$posts_columns = array();
-		$posts_columns['cb'] = '<input type="checkbox" />';
+		$posts_columns['cb'] = '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />';
 		$posts_columns['icon'] = '';
 		/* translators: column name */
 		$posts_columns['title'] = _x( 'File', 'column name' );
Index: class-wp-links-list-table.php
===================================================================
--- class-wp-links-list-table.php	(revision 21296)
+++ class-wp-links-list-table.php	(working copy)
@@ -76,7 +76,7 @@
 
 	function get_columns() {
 		return array(
-			'cb'         => '<input type="checkbox" />',
+			'cb'		 => '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />',
 			'name'       => _x( 'Name', 'link name' ),
 			'url'        => __( 'URL' ),
 			'categories' => __( 'Categories' ),
Index: class-wp-terms-list-table.php
===================================================================
--- class-wp-terms-list-table.php	(revision 21296)
+++ class-wp-terms-list-table.php	(working copy)
@@ -96,7 +96,7 @@
 		global $taxonomy, $post_type;
 
 		$columns = array(
-			'cb'          => '<input type="checkbox" />',
+			'cb'          => '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />',
 			'name'        => _x( 'Name', 'term name' ),
 			'description' => __( 'Description' ),
 			'slug'        => __( 'Slug' ),
Index: class-wp-users-list-table.php
===================================================================
--- class-wp-users-list-table.php	(revision 21296)
+++ class-wp-users-list-table.php	(working copy)
@@ -159,7 +159,7 @@
 
 	function get_columns() {
 		$c = array(
-			'cb'       => '<input type="checkbox" />',
+			'cb'       => '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />',
 			'username' => __( 'Username' ),
 			'name'     => __( 'Name' ),
 			'email'    => __( 'E-mail' ),
Index: class-wp-ms-themes-list-table.php
===================================================================
--- class-wp-ms-themes-list-table.php	(revision 21296)
+++ class-wp-ms-themes-list-table.php	(working copy)
@@ -170,7 +170,7 @@
 		global $status;
 
 		return array(
-			'cb'          => '<input type="checkbox" />',
+			'cb'          => '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />',
 			'name'        => __( 'Theme' ),
 			'description' => __( 'Description' ),
 		);
Index: class-wp-ms-users-list-table.php
===================================================================
--- class-wp-ms-users-list-table.php	(revision 21296)
+++ class-wp-ms-users-list-table.php	(working copy)
@@ -111,7 +111,7 @@
 
 	function get_columns() {
 		$users_columns = array(
-			'cb'         => '<input type="checkbox" />',
+			'cb'         => '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />',
 			'username'   => __( 'Username' ),
 			'name'       => __( 'Name' ),
 			'email'      => __( 'E-mail' ),
Index: class-wp-plugins-list-table.php
===================================================================
--- class-wp-plugins-list-table.php	(revision 21296)
+++ class-wp-plugins-list-table.php	(working copy)
@@ -175,7 +175,7 @@
 		global $status;
 
 		return array(
-			'cb'          => !in_array( $status, array( 'mustuse', 'dropins' ) ) ? '<input type="checkbox" />' : '',
+			'cb'          => !in_array( $status, array( 'mustuse', 'dropins' ) ) ? '<label class="screen-reader-text" for="cb-cb">' . __('Select all') . '</label><input id="cb-cb" type="checkbox" />' : '',
 			'name'        => __( 'Plugin' ),
 			'description' => __( 'Description' ),
 		);