Index: wp-admin/includes/dashboard.php
===================================================================
--- wp-admin/includes/dashboard.php	(revision 22376)
+++ wp-admin/includes/dashboard.php	(working copy)
@@ -1242,7 +1242,6 @@
 	<div class="welcome-panel-column-container">
 	<div class="welcome-panel-column">
 		<h4><?php _e( 'Get Started' ); ?></h4>
-		<p><?php _e( 'First, tweak the look of your site:' ); ?></p>
 		<a class="button-primary welcome-button load-customize hide-if-no-customize" href="<?php echo wp_customize_url(); ?>"><?php _e( 'Customize Your Site' ); ?></a>
 		<a class="button-primary welcome-button hide-if-customize" href="<?php echo admin_url( 'themes.php' ); ?>"><?php _e( 'Customize Your Site' ); ?></a>
 		<?php if ( current_user_can( 'install_themes' ) || ( current_user_can( 'switch_themes' ) && count( wp_get_themes( array( 'allowed' => true ) ) ) > 1 ) ) : ?>
@@ -1253,25 +1252,25 @@
 		<h4><?php _e( 'Next Steps' ); ?></h4>
 		<ul>
 		<?php if ( 'page' == get_option( 'show_on_front' ) && ! get_option( 'page_for_posts' ) ) : ?>
-			<li><?php printf( '<a href="%s">' . __( 'Edit your front page' ) . '</a>', get_edit_post_link( get_option( 'page_on_front' ) ) ); ?></li>
-			<li><?php printf( '<a href="%s">' . __( 'Add additional pages' ) . '</a>', admin_url( 'post-new.php?post_type=page' ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-edit-page">' . __( 'Edit your front page' ) . '</a>', get_edit_post_link( get_option( 'page_on_front' ) ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-add-page">' . __( 'Add additional pages' ) . '</a>', admin_url( 'post-new.php?post_type=page' ) ); ?></li>
 		<?php elseif ( 'page' == get_option( 'show_on_front' ) ) : ?>
-			<li><?php printf( '<a href="%s">' . __( 'Edit your front page' ) . '</a>', get_edit_post_link( get_option( 'page_on_front' ) ) ); ?></li>
-			<li><?php printf( '<a href="%s">' . __( 'Add additional pages' ) . '</a>', admin_url( 'post-new.php?post_type=page' ) ); ?></li>
-			<li><?php printf( '<a href="%s">' . __( 'Add a blog post' ) . '</a>', admin_url( 'post-new.php' ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-edit-page">' . __( 'Edit your front page' ) . '</a>', get_edit_post_link( get_option( 'page_on_front' ) ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-add-page">' . __( 'Add additional pages' ) . '</a>', admin_url( 'post-new.php?post_type=page' ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-write-blog">' . __( 'Add a blog post' ) . '</a>', admin_url( 'post-new.php' ) ); ?></li>
 		<?php else : ?>
-			<li><?php printf( '<a href="%s">' . __( 'Write your first blog post' ) . '</a>', admin_url( 'post-new.php' ) ); ?></li>
-			<li><?php printf( '<a href="%s">' . __( 'Add an About page' ) . '</a>', admin_url( 'post-new.php?post_type=page' ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-write-blog">' . __( 'Write your first blog post' ) . '</a>', admin_url( 'post-new.php' ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-add-page">' . __( 'Add an About page' ) . '</a>', admin_url( 'post-new.php?post_type=page' ) ); ?></li>
 		<?php endif; ?>
-			<li><?php printf( '<a href="%s">' . __( 'View your site' ) . '</a>', home_url( '/' ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-view-site">' . __( 'View your site' ) . '</a>', home_url( '/' ) ); ?></li>
 		</ul>
 	</div>
 	<div class="welcome-panel-column welcome-panel-last">
-		<h4><?php _e( 'Learn How To' ); ?></h4>
+		<h4><?php _e( 'More Actions' ); ?></h4>
 		<ul>
-			<li><?php printf( '<a id="wp350_add_images" href="%s">' . __( 'Add image/media' ) . '</a>', admin_url( 'media-new.php' ) ); ?></li>
-			<li><?php printf( '<a id="wp350_widgets" href="%s">' . __( 'Add/remove widgets' ) . '</a>', admin_url( 'widgets.php' ) ); ?></li>
-			<li><?php printf( '<a id="wp350_edit_menu" href="%s">' . __( 'Edit your navigation menu' ) . '</a>', admin_url( 'nav-menus.php' ) ); ?></li>
+			<li><?php printf( '<div class="welcome-widgets-menus">Manage <a href="%s">' . __( 'widgets' ) . '</a> or <a href="%s">' . __( 'menus' ) . '</a></div>', admin_url( 'widgets.php' ), admin_url( 'nav-menus.php' ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-comments">' . __( 'Turn comments on or off' ) . '</a>', admin_url( 'options-discussion.php' ) ); ?></li>
+			<li><?php printf( '<a href="%s" class="welcome-learn-more">' . __( 'Learn more about getting started' ) . '</a>', 'http://codex.wordpress.org/First_Steps_With_WordPress' ); ?></li>
 		</ul>
 	</div>
 	</div>
Index: wp-admin/css/wp-admin.css
===================================================================
--- wp-admin/css/wp-admin.css	(revision 22376)
+++ wp-admin/css/wp-admin.css	(working copy)
@@ -2219,13 +2219,13 @@
 	border-style: solid;
 	border-radius: 3px;
 	font-size: 13px;
-	line-height: 1.6em;
+	line-height: 2.1em;
 }
 
 .welcome-panel h3 {
 	margin: 0;
 	font-family: "HelveticaNeue-Light", "Helvetica Neue Light", "Helvetica Neue", sans-serif;
-	font-size: 32px;
+	font-size: 21px;
 	font-weight: normal;
 	line-height: 1.2;
 }
@@ -2235,7 +2235,7 @@
 }
 
 .welcome-panel .about-description {
-	font-size: 18px;
+	font-size: 16px;
 	margin: 0;
 }
 
@@ -2265,7 +2265,7 @@
 	font: normal 15px sans-serif;
 	height: 46px;
 	line-height: 44px;
-    margin: -9px 0 3px;
+    margin: 15px 0 3px;
     padding: 0 36px;
 }
 
@@ -2299,16 +2299,94 @@
 }
 
 .welcome-panel-column p {
-	margin-top: 5px;
+	margin-top: 7px;
 }
 
+.welcome-panel .welcome-add-page {
+	background: url('../images/welcome-icons.png') no-repeat 0 -1px;
+}
+
+.welcome-panel .welcome-edit-page {
+	background: url('../images/welcome-icons.png') no-repeat 0px -92px;
+}
+
+.welcome-panel .welcome-learn-more {
+	background: url('../images/welcome-icons.png') no-repeat 0px -138px;
+}
+
+.welcome-panel .welcome-comments {
+	background: url('../images/welcome-icons.png') no-repeat 0px -184px;
+}
+
+.welcome-panel .welcome-view-site {
+	background: url('../images/welcome-icons.png') no-repeat 0px -276px;
+}
+
+.welcome-panel .welcome-widgets-menus {
+	background: url('../images/welcome-icons.png') no-repeat 1px -230px;
+	line-height: 14px;
+}
+ 
+.welcome-panel .welcome-write-blog {
+ 	background: url('../images/welcome-icons.png') no-repeat 0px -46px;
+}
+
+.welcome-panel .welcome-add-page,
+.welcome-panel .welcome-edit-page,
+.welcome-panel .welcome-learn-more,
+.welcome-panel .welcome-comments,
+.welcome-panel .welcome-view-site,
+.welcome-panel .welcome-widgets-menus,
+.welcome-panel .welcome-write-blog {
+	background-size: 16px;
+	display: block;
+	padding: 2px 0 8px 32px;
+}
+
+@media only screen and (-webkit-min-device-pixel-ratio: 1.5) {
+	.welcome-panel .welcome-add-page {
+		background: url('../images/welcome-icons-2x.png') no-repeat 0 -1px;
+		background-size: 16px;
+	}
+	
+	.welcome-panel .welcome-edit-page {
+		background: url('../images/welcome-icons-2x.png') no-repeat 0px -92px;
+		background-size: 16px;
+	}
+	
+	.welcome-panel .welcome-learn-more {
+		background: url('../images/welcome-icons-2x.png') no-repeat 0px -138px;
+		background-size: 16px;
+	}
+	
+	.welcome-panel .welcome-comments {
+		background: url('../images/welcome-icons-2x.png') no-repeat 0px -184px;
+		background-size: 16px;
+	}
+	
+	.welcome-panel .welcome-view-site {
+		background: url('../images/welcome-icons-2x.png') no-repeat 0px -276px;
+		background-size: 16px;
+	}
+	
+	.welcome-panel .welcome-widgets-menus {
+		background: url('../images/welcome-icons-2x.png') no-repeat 1px -230px;
+		background-size: 16px;
+	}
+	 
+	.welcome-panel .welcome-write-blog {
+	 	background: url('../images/welcome-icons-2x.png') no-repeat 0px -46px;
+	 	background-size: 16px;
+	}
+}
+
 .welcome-panel .welcome-panel-column ul {
-	margin: 0.4em 1em 1em 1.3em;
+	margin: 0.8em 1em 1em 0;
 }
 
 .welcome-panel .welcome-panel-column li {
-	list-style-type: disc;
-	padding-left: 2px;
+    line-height: 16px;
+    list-style-type: none;
 }
 
 @media screen and (max-width: 870px) {
@@ -2331,6 +2409,16 @@
 	.welcome-panel .welcome-panel-column ul {
 		margin: 0.4em 0 0;
 	}
+	
+	.welcome-panel .welcome-add-page,
+	.welcome-panel .welcome-edit-page,
+	.welcome-panel .welcome-learn-more,
+	.welcome-panel .welcome-comments,
+	.welcome-panel .welcome-view-site,
+	.welcome-panel .welcome-widgets-menus,
+	.welcome-panel .welcome-write-blog {
+		padding-left: 25px;
+	}
 }
 
 /**